/**
 * Copyright 2018-2019, Optimizely
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import * as React from 'react';
import { WithOptimizelyProps } from './withOptimizely';
import { VariableValuesObject } from './client';
export interface FeatureProps extends WithOptimizelyProps {
    feature: string;
    timeout?: number;
    autoUpdate?: boolean;
    children: (isEnabled: boolean, variables: VariableValuesObject) => React.ReactNode;
}
export interface FeatureState {
    canRender: boolean;
    isEnabled: boolean;
    variables: VariableValuesObject;
}
export declare const OptimizelyFeature: React.ForwardRefExoticComponent<Pick<FeatureProps, "children" | "feature" | "timeout" | "autoUpdate"> & React.RefAttributes<unknown>>;
